# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.CloudRun.V1alpha1.Model.Probe do
  @moduledoc """
  Not supported by Cloud Run Probe describes a health check to be performed against a container to determine whether it is alive or ready to receive traffic.

  ## Attributes

  *   `exec` (*type:* `GoogleApi.CloudRun.V1alpha1.Model.ExecAction.t`, *default:* `nil`) - (Optional) One and only one of the following should be specified. Exec specifies the action to take. A field inlined from the Handler message.
  *   `failureThreshold` (*type:* `integer()`, *default:* `nil`) - (Optional) Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.
  *   `httpGet` (*type:* `GoogleApi.CloudRun.V1alpha1.Model.HTTPGetAction.t`, *default:* `nil`) - (Optional) HTTPGet specifies the http request to perform. A field inlined from the Handler message.
  *   `initialDelaySeconds` (*type:* `integer()`, *default:* `nil`) - (Optional) Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
  *   `periodSeconds` (*type:* `integer()`, *default:* `nil`) - (Optional) How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1. Maximum value is 3600. Must be greater or equal than timeout_seconds.
  *   `successThreshold` (*type:* `integer()`, *default:* `nil`) - (Optional) Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup Probes.
  *   `tcpSocket` (*type:* `GoogleApi.CloudRun.V1alpha1.Model.TCPSocketAction.t`, *default:* `nil`) - (Optional) TCPSocket specifies an action involving a TCP port. TCP hooks not yet supported A field inlined from the Handler message.
  *   `timeoutSeconds` (*type:* `integer()`, *default:* `nil`) - (Optional) Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. Maximum value is 3600. Must be smaller than period_seconds. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :exec => GoogleApi.CloudRun.V1alpha1.Model.ExecAction.t() | nil,
          :failureThreshold => integer() | nil,
          :httpGet => GoogleApi.CloudRun.V1alpha1.Model.HTTPGetAction.t() | nil,
          :initialDelaySeconds => integer() | nil,
          :periodSeconds => integer() | nil,
          :successThreshold => integer() | nil,
          :tcpSocket => GoogleApi.CloudRun.V1alpha1.Model.TCPSocketAction.t() | nil,
          :timeoutSeconds => integer() | nil
        }

  field(:exec, as: GoogleApi.CloudRun.V1alpha1.Model.ExecAction)
  field(:failureThreshold)
  field(:httpGet, as: GoogleApi.CloudRun.V1alpha1.Model.HTTPGetAction)
  field(:initialDelaySeconds)
  field(:periodSeconds)
  field(:successThreshold)
  field(:tcpSocket, as: GoogleApi.CloudRun.V1alpha1.Model.TCPSocketAction)
  field(:timeoutSeconds)
end

defimpl Poison.Decoder, for: GoogleApi.CloudRun.V1alpha1.Model.Probe do
  def decode(value, options) do
    GoogleApi.CloudRun.V1alpha1.Model.Probe.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CloudRun.V1alpha1.Model.Probe do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
